=== man/Makefile ===
# $Id: Makefile,v 1.1 1998/03/13 08:16:18 gaertner Exp $
#----------------------------------------------------------------------

#
# Makefile for pretzel and pretzel-it manpages
#


# have a look at both -- I forgot the line :-(

pretzel:
	nroff -man pretzel.1 | less

pretzel.1.ps: pretzel.1
	groff -man pretzel.1 > pretzel.1.ps

pretzel-it:
	nroff -man pretzel-it.1 | less

pretzel-it.1.ps: pretzel-it.1
	groff -man pretzel-it.1 > pretzel-it.1.ps

# DO NOT USE WHEN INSTALLING

release:
	cp pretzel-it.1 pretzel.1 /users/gaertner/man/man1
