=== contrib/leew/Makefile ===
# $Id: Makefile,v 1.2 1996/12/16 19:18:22 gaertner Exp $
#----------------------------------------------------------------------

#
# Makefile for Lee Wittenberg's Java prettyprinting filter for noweb
#


test: prettyjava
	noweave -delay -filter prettyjava -index -backend ./totex jtest.nw > jtest.tex


prettyjava: java.ft java.fg
	pretzel-it -n java prettyjava


totex: totex.nw
	notangle < totex.nw > totex.icn
	icont totex.icn

noweb.sty: support.nw
	notangle -Rnoweb.sty > noweb.sty

clean:
	rm -f *.tex *.log *.dvi *.o *.toc *.aux
