=== doc/pretzelbook/Makefile ===
#
# $Id$
#
# Makefile for the Pretzelbook
#
# $Log$
#
#



# where to copy any latex styles to:
#TEXINPUTSDIR	= /users/gaertner/tex/inputs

#
LATEX	= latex
BIBTEX	= bibtex
MAKEINDEX	= makeindex

# ------------------------------------------------------------------------



# ------------------------------------------------------------------------

pretzelbook:
	$(LATEX) pretzelbook.tex
	$(MAKEINDEX) pretzelbook
	$(BIBTEX) pretzelbook
	$(LATEX) pretzelbook.tex
	$(LATEX) pretzelbook.tex



# ------------------------------------------------------------------------

clean:
	rm -f *.toc *.log *.aux *.idx *.ilg *.bbl *.blg *.ind

clobber: clean
	rm -f *.dvi

#bundle:
#	tar cf $(DISTNAME).tar $(REPFILES) $(MANFILES) $(BOTHFILES)	\
#		$(DISTFILES)


release:
