=== doc/styles/Makefile ===
# $Id$
#----------------------------------------------------------------------

#
# Makefile for XXX
#

# own pretzel styles
STYLES	= pretzel-latex.sty pretzeldoc.sty pretzel-noweb.sty

# the pretzel-noweb.sty has to be made first
STYLESRC	= pretzel-noweb-style.nw

# other styles that are standard but not met frequently
OTHERSTYLES = moreverb.sty

TEXINPUTSDIR = /users/gaertner/tex/inputs

pretzel-noweb.sty: pretzel-noweb-style.nw
	notangle pretzel-noweb-style.nw > pretzel-noweb.sty

pretzel-noweb-style.dvi: pretzel-noweb-style.nw
	noweave -delay -index pretzel-noweb-style.nw > pretzel-noweb-style.tex
	latex pretzel-noweb-style.tex
	latex pretzel-noweb-style.tex

clean:
	rm *.aux *.log *.tex

clobber: clean
	rm *.dvi

release: $(STYLES) $(MORESTYLES) $(OTHERSTYLES)
	cp $(STYLES) $(MORESTYLES) $(OTHERSTYLES) $(TEXINPUTSDIR)
