=== debian/changelog ===
pretzel (2.0n-2-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with GCC 4.3 (Closes: #461686).

 -- Luk Claes <luk@debian.org>  Sun, 09 Mar 2008 17:44:25 +0000
