=== debian/control ===
Source: pretzel
Section: devel
Priority: extra
Maintainer: Anthony Towns <ajt@debian.org>
Standards-Version: 3.1.1
Build-Depends: nowebm, flex (>= 2.4.6), bison (>= 1.19), debhelper

Package: pretzel
Architecture: any
Depends: ${shlibs:Depends}, flex (>= 2.4.6), bison (>= 1.19)
Recommends: noweb | nowebm
Description: Prettyprinter generator for noweb
 Pretzel is a system that builds prettyprinters; that is programs that
 will take some plain ASCII source code and generate a LaTeXified version
 for presentation.
 .
 Pretzel has hooks to integrate with noweb, so that code chunks may be
 prettyprinted with pretzel's generated prettyprinters.
 .
 Example prettyprinter source for C, C++, Pascal, and Dijkstra's Guarded
 Command Language are included.
