=== debian/rules ===
#!/usr/bin/make -f
# MAde with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Cristoph Lameter.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-stamp
build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) CFLAGS="-O2 -g -Wall -W -I`pwd`/include -L`pwd` -lpretzel"

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	# Add here commands to clean up after the build process.
	$(MAKE) clobber
	rm -rf tmpcee tmppascal
	rm -f contrib/noweb/general/testpp


	dh_clean

# Build architecture-independent files here.
binary-indep: build
# We have nothing to do by default.

DST := $(PWD)/debian/tmp

# Build architecture-dependent files here.
binary-arch: build
#	dh_testversion
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the files into debian/tmp
	$(MAKE) install DESTDIR=`pwd`/debian/tmp
	cp doc/pretzelbook/pretzelbook.dvi debian/tmp/usr/share/doc/pretzel/
        
	mkdir -p $(DST)/usr/share/doc/pretzel/examples/simpas
	cp -a languages/examples  $(DST)/usr/share/doc/pretzel/examples/simpas
	cp -a languages/cee       $(DST)/usr/share/doc/pretzel/examples/
	cp -a languages/cplusplus $(DST)/usr/share/doc/pretzel/examples/
	cp -a languages/pascal    $(DST)/usr/share/doc/pretzel/examples/

	mkdir $(DST)/usr/share/doc/pretzel/examples/contrib
	cp -r contrib/*  $(DST)/usr/share/doc/pretzel/examples/contrib/

	rm -f debian/tmp/usr/share/doc/pretzel/examples/*/index.html debian/tmp/usr/share/doc/pretzel/examples/*/index.list

#	for a in cee pascal; do \
#	  mkdir tmp$$a; cd tmp$$a; \
#	  cp ../debian/tmp/usr/share/doc/pretzel/examples/$${a}/* .; \
#	  PATH=$$PATH:../debian/tmp/usr/bin PRETZEL_LIBDIR=../debian/tmp/usr/lib/pretzel PRETZEL_INCLUDE=../debian/tmp/usr/include/pretzel ../pretzel-it/pretzel-it $${a} $${a}pp; \
#	  PATH=$$PATH:../debian/tmp/usr/bin PRETZEL_LIBDIR=../debian/tmp/usr/lib/pretzel PRETZEL_INCLUDE=../debian/tmp/usr/include/pretzel ../pretzel-it/pretzel-it -n $${a} pretty$${a}; \
#	  mv $${a}pp pretty$${a} ../debian/tmp/usr/bin/ ;\
#	  cd ..; rm -rf tmp$$a; \
#	done

	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installinit
	dh_installcron
	dh_installmanpages
#	dh_undocumented
	dh_installchangelogs diary diary-1.1
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
#	dh_makeshlibs
	dh_md5sums
	dh_builddeb

source diff:                                                                  
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary
